<template>
  <div class="mt-10 pt-3">
    <template v-if="$fetchState.pending">
      <div class="text-center mt-10">
        <v-progress-circular :size="96" color="light-blue" indeterminate></v-progress-circular>
      </div>
    </template>
    <template v-else>
      <v-alert v-if="orderId" outlined type="success" text>
        Спасибо за заказ! Наш менеджер свяжется с вами в ближайшее время. Номер вашего заказа —
        <strong>{{ orderId }}</strong>
      </v-alert>
      <v-alert v-else-if="orderError" outlined type="error" text>
        К сожалению, при регистрации заказа возникла ошибка. Приносим свои извенения за неудобства.
      </v-alert>

      <v-alert
        v-else-if="products.length === 0"
        border="top"
        colored-border
        type="info"
        elevation="2"
        v-text="$t('text.cart-empty')"
      ></v-alert>

      <v-stepper v-else v-model="step" vertical>
        <v-stepper-step :complete="step > 1" step="1">{{ $t('heading.cart') }}</v-stepper-step>
        <v-stepper-content step="1">
          <v-card v-if="products.length" flat>
            <v-list two-line>
              <v-list-item v-for="(product, i) in products" :key="`cart-page-product-${product.id}`">
                <template v-if="product.deleted">
                  <div>
                    <span v-text="$t('text.cart-item-deleted')"></span>
                    <a
                      href="#"
                      @click.prevent="setDeletedState(product.id, false)"
                      v-text="$t('button.undo-delete')"
                    ></a>
                  </div>
                </template>
                <template v-else>
                  <v-list-item-avatar width="200" height="200">
                    <nuxt-link :to="`/catalog/${product.category}/${product.id}`">
                      <v-img :src="product.images[0].small" contain></v-img>
                    </nuxt-link>
                  </v-list-item-avatar>

                  <v-list-item-content>
                    <v-list-item-title class="font-weight-light subheading">
                      <nuxt-link
                        :to="`/catalog/${product.category}/${product.id}`"
                        v-text="product.full_name"
                      ></nuxt-link>
                    </v-list-item-title>
                    <v-list-item-subtitle class="pt-3">
                      <v-chip class="font-weight-medium black--text" color="light-green lighten-3">
                        {{ product.price | formattedCost }} ₽
                      </v-chip>
                      <span v-if="(cart[i] || 0).quantity > 1">x {{ cart[i].quantity }}</span>
                    </v-list-item-subtitle>
                  </v-list-item-content>

                  <v-list-item-action>
                    <div class="d-flex">
                      <v-text-field
                        v-model="product.quantity"
                        class="mr-5"
                        :label="$t('text.qty')"
                        style="width: 100px"
                      ></v-text-field>
                      <v-btn v-show="1" color="red lighten-2" fab dark small @click="setDeletedState(product.id, true)">
                        <v-icon>mdi-close</v-icon>
                      </v-btn>
                    </div>
                  </v-list-item-action>
                </template>
              </v-list-item>
            </v-list>

            <v-divider></v-divider>

            <v-row>
              <v-col cols="6">
                <div class="font-weight-medium black--text">
                  <span>{{ $t('text.total-price') }}:</span>
                  <v-chip color="deep-orange" dark>{{ totalPrice | formattedCost }} ₽</v-chip>
                </div>
              </v-col>
              <v-col cols="6" class="text-right">
                <v-btn color="indigo" dark large @click="step = 2">{{ $t('button.order') }}</v-btn>
              </v-col>
            </v-row>
          </v-card>
        </v-stepper-content>

        <v-stepper-step :complete="step > 2" step="2">{{ $t('heading.order-registration') }}</v-stepper-step>
        <v-stepper-content step="2">
          <v-form ref="order-form">
            <v-card flat>
              <v-row align="start">
                <v-col cols="6">
                  <v-text-field
                    v-model="userDataName"
                    :label="$t('text.field-name')"
                    clearable
                    prepend-inner-icon="mdi-account-box-multiple"
                  ></v-text-field>
                  <v-text-field
                    v-model="userDataEmail"
                    :label="$t('text.field-email')"
                    clearable
                    prepend-inner-icon="mdi-email-check-outline"
                  ></v-text-field>
                  <v-text-field
                    v-model="userDataTel"
                    :label="$t('text.field-phone')"
                    clearable
                    prepend-inner-icon="mdi-cellphone-iphone"
                  ></v-text-field>
                  <v-textarea
                    v-model="userDataComment"
                    :label="$t('text.field-comment')"
                    rows="2"
                    clearable
                    prepend-inner-icon="mdi-message-reply-text"
                  ></v-textarea>

                  <div class="d-flex">
                    <v-btn color="deep-purple lighten-1" dark @click="step = 1">{{ $t('button.go-to-back') }}</v-btn>
                    <v-spacer></v-spacer>
                    <v-btn
                      color="light-green"
                      dark
                      large
                      :disabled="$v.$invalid"
                      @click="step = 3"
                      v-text="$t('button.continue')"
                    ></v-btn>
                  </div>
                </v-col>
                <v-col cols="6"> </v-col>
              </v-row>
            </v-card>
          </v-form>
        </v-stepper-content>

        <v-stepper-step step="3">{{ $t('heading.order-confirmation') }}</v-stepper-step>
        <v-stepper-content step="3">
          <v-card>
            <v-list subheader>
              <v-subheader>{{ $t('heading.personal-data') }}</v-subheader>
              <v-list-item>
                <v-list-item-content>
                  <v-list-item-title>{{ $t('text.field-name') }}</v-list-item-title>
                  <v-list-item-subtitle>{{ userDataName }}</v-list-item-subtitle>
                </v-list-item-content>
              </v-list-item>
              <v-list-item>
                <v-list-item-content>
                  <v-list-item-title>{{ $t('text.field-email') }}</v-list-item-title>
                  <v-list-item-subtitle>{{ userDataEmail }}</v-list-item-subtitle>
                </v-list-item-content>
              </v-list-item>
              <v-list-item>
                <v-list-item-content>
                  <v-list-item-title>{{ $t('text.field-phone') }}</v-list-item-title>
                  <v-list-item-subtitle>{{ userDataTel }}</v-list-item-subtitle>
                </v-list-item-content>
              </v-list-item>
            </v-list>

            <v-divider></v-divider>

            <div class="mt-5">
              <v-progress-circular v-if="orderLoading" indeterminate color="deep-orange"></v-progress-circular>
              <v-btn
                v-else
                color="deep-orange"
                class="white--text"
                depressed
                large
                @click="send"
                v-text="$t('button.order')"
              ></v-btn>
            </div>
          </v-card>
        </v-stepper-content>
      </v-stepper>
    </template>
  </div>
</template>

<script>
import { validationMixin } from 'vuelidate'
import { required } from 'vuelidate/lib/validators'

export default {
  mixins: [validationMixin],

  async fetch() {
    const { cart } = this.$store.state.catalog
    const list = cart.map(item => item.id)
    const params = { ids: list.join(','), groupby: 0 }

    if (!cart.length) {
      return false
    }

    try {
      const data = await this.$api('v1').request('oasis/products', { params })

      this.products = data.map(item => {
        return {
          ...item,
          get quantity() {
            const cartItem = cart.find(i => i.id === item.product_oasis_id)
            return cartItem.quantity
          },
          get deleted() {
            const cartItem = cart.find(i => i.id === item.product_oasis_id)
            return cartItem.deleted
          },
        }
      })
    } catch (err) {
      console.error(err)
    }
  },

  fetchOnServer: false,

  data: vm => ({
    title: '',
    titleMap: ['cart', 'order', 'confirm-order'],
    step: 1,
    products: [],
    userDataName: '',
    userDataEmail: '',
    userDataTel: '',
    userDataComment: '',
    orderId: 0,
    orderError: false,
    orderLoading: false,
  }),

  computed: {
    cart() {
      return this.$store.state.catalog.cart || []
    },

    totalQuantity() {
      return this.cart.length || 0
    },

    totalPrice() {
      if (!this.products.length || !this.cart.length) return 0
      return this.products.reduce((acc, cur, i) => acc + parseFloat(cur.price) * (this.cart[i] || 1).quantity, 0)
    },
  },

  watch: {
    step(val) {
      const key = this.titleMap[val - 1]
      this.title = this.$t(`heading.${key}`)
    },

    /* products: {
      handler(val) {},
      deep: true,
    }, */
  },

  created() {
    this.title = this.$t('heading.cart')
  },

  methods: {
    setDeletedState(id, deleted) {
      this.$store.commit('catalog/SET_ITEM_DELETED', { id, deleted })
    },

    async send() {
      const vm = this
      const { cart } = vm
      const userData = {
        user_name: vm.userDataName,
        user_email: vm.userDataEmail,
        user_tel: vm.userDataTel,
        user_comment: vm.userDataComment,
        order: { cart },
      }

      this.orderLoading = true

      try {
        const { data } = await this.$api('v1').request('orders/add', userData)

        this.$store.commit('catalog/SET_CART', [])
        this.orderLoading = false
        this.orderId = data._id
      } catch (err) {
        this.orderError = true
        console.error(err)
      }
    },
  },

  validations: {
    userDataName: { required },
    userDataEmail: { required },
    userDataTel: { required },
  },

  head() {
    return {
      title: this.title,
    }
  },
}
</script>
